@ECHO OFF
SETLOCAL ENABLEDELAYEDEXPANSION

::  "Dflt=0" - Use 'Chapter 1-X' / =1" - Use 'Chapter 01-XX' format
SET "Dflt=0"
::  "Mode=2" - Use existing chapter names, INCLUDING blank, NO mods
::  "Mode=1" - Use existing chapter names, EXCEPT blank... use 'Dflt'
::  "Mode=0" - Ignore existing chapter names & use 'Dflt' format
SET "Mode=0"
::  "LogQ=0" - NO logging / =1" - Generate basic process log
SET "LogQ=0"
SET "LogDate=%DATE:~10,4%-%DATE:~7,2%-%DATE:~4,2%"
SET "LogTime=%TIME:~0,2%_%TIME:~3,2%_%TIME:~6,2%"
SET "LogFile=%~n0.%LogDate%_%LogTime%.log"
SET "MaxSize=2200"

IF NOT "%~1"=="" FOR %%A IN (%*) DO (
	IF EXIST "%%~A\" (
		FOR /F "USEBACKQ TOKENS=*" %%D IN (`DIR /B /S "%%~A\*.txt"`) DO ( 
			CALL :IsOK2Q "%%~fD" )
	) ELSE IF "%%~xA"==".txt" ( CALL :IsOK2Q "%%~fA" )
) ELSE ( CALL :IsOK2Q "%CD%\MyFile.txt" )

IF %LogQ% NEQ 0 ( CALL :LogCfg )

FOR /L %%S in (1,1,!MCQueue[0]!) DO (
	SET "SrcFile=!MCQueue[%%S]!" && SET "Cnt="
	SET "DstFile=!SrcFile:txt=chapters.txt!"
	IF EXIST "!DstFile!" ( DEL !DstFile! )
	FOR /F "USEBACKQ TOKENS=*" %%L IN (!SrcFile!) DO (
		SET "Line=%%L" && FOR %%R IN (^\ ^") DO ( SET "Line=!Line:%%R=!" )
		ECHO %%L| FINDSTR /R "^[0][0-9]\:[0-5][0-9]\:[0-5][0-9]\.[0-9]*">NUL
		IF !ERRORLEVEL! EQU 0 ( CALL :MCCore "!Line!" )
	)
	IF %LogQ% NEQ 0 IF EXIST "!DstFile!" (
		ECHO 'GENERATED' - %TIME%    - !DstFile!>>"%LogFile%" )
)

GOTO :TheEnd

:::::::::::::::::
:IsOK2Q
:::::::::::::::::

IF NOT EXIST %1 ( SET "Msg=DOES NOT EXIST - '%~1'" && GOTO :Fail2Q )
FOR %%I IN (.chapters README) DO (
	ECHO "%~n1"| FINDSTR %%I>NUL
	IF !ERRORLEVEL! EQU 0 ( SET "Msg=FILTERED TYPE  - '%~1'" && GOTO :Fail2Q )
)
IF %~z1 GTR %MaxSize% ( SET "Msg=GTR THAN %MaxSize%B - '%~1'" && GOTO :Fail2Q )
TYPE %1| FINDSTR /R "[0][0-9]\:[0-5][0-9]\:[0-5][0-9]\.[0-9]*">NUL
IF !ERRORLEVEL! NEQ 0 ( SET "Msg=NO TMSTMP DATA - '%~1'" && GOTO :Fail2Q )
SET /A "MCQueue[0]+=1" && SET "MCQueue[!MCQueue[0]!]=%1"

EXIT /B 0

:::::::::::::::::
:Fail2Q
:::::::::::::::::

IF %LogQ% NEQ 0 ( ECHO 'DISCARDED' - !Msg:^'=^"!>>"%LogFile%" )

EXIT /B 1

:::::::::::::::::
:LogCfg
:::::::::::::::::

ECHO. >>"%LogFile%" 
ECHO ++   Display Dflt =     %Dflt%   ++>>"%LogFile%"
ECHO ++   Output Mode  =     %Mode%   ++>>"%LogFile%"
ECHO. >>"%LogFile%" 

EXIT /B 0

:::::::::::::::::
:MCCore
:::::::::::::::::

SET /A "Cnt+=1" && SET "Name="
IF !Cnt! LSS 10 ( SET "Nmbr=0!Cnt!" ) ELSE ( SET "Nmbr=!Cnt!" )
IF !Dflt! NEQ 0 ( SET "Disp=!Nmbr!" ) ELSE ( SET "Disp=!Cnt!" )
FOR /F "TOKENS=1 DELIMS= " %%M IN (%1) DO ( SET "Mark=%%M" )
IF !Mode! NEQ 0 FOR /F "TOKENS=5 DELIMS=\:" %%N IN (%1) DO (
	ECHO %%N| FINDSTR /R "^[0][0-9]$">NUL
	IF !ERRORLEVEL! EQU 0 ( SET "Name=!Mark!" ) ELSE ( SET "Name=%%N" )
)
IF !Mode! NEQ 2 IF "!Name!"=="" ( SET "Name=Chapter !Disp!" )
ECHO CHAPTER!Nmbr!=!Mark!>>!DstFile!
ECHO CHAPTER!Nmbr!NAME=!Name!>>!DstFile!

EXIT /B 0

:::::::::::::::::
:TheEnd
:::::::::::::::::

REM IF %LogQ% NEQ 0 ( TYPE "%LogFile%" && ECHO. && PAUSE )

ENDLOCAL